import com.cherokee.AccessorMethods;
import com.cherokee.tester.TestAccessorMethods;
import com.cherokee.event.keyboard.KeyBoard;
import com.cherokee.event.mouse.*;
import java.awt.Dimension;

/**
 * This is a sample script to be ran when using the supplied test.conf
 * Copyright (C) 2007  Travis Burtrum (moparisthebest)
 * <p/>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p/>
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p/>
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 * <p/>
 * The code *may* be used under a lesser license (such as the LGPL) only with
 * express written permission from Travis Burtrum (moparisthebest)
 */
public class TestScript extends com.cherokee.Script {

    public static String[] commands = {"testKB","testMouseClick","testMouseMove","testSleep","testArgs","testEnterExit"};

    private int test;
    private Dimension appletSize;
    private String[] args;

    private int anInt;

    private KeyBoard kb;
    private Mouse mouse;

    public boolean scriptStarting(String cmd, String[] args, AccessorMethods ac) {
        
	for(int f=0;f<commands.length;f++)
		if(cmd.equals(commands[f]))
			test = f;
	this.args = args;
	appletSize = ((TestAccessorMethods)ac).getAppletDimension();
        kb = new KeyBoard(ac);
        mouse = new Mouse(ac);
	mouse.setMousePathGen(new Spline());
	anInt = 0;
        return true;
    }

    public void mainLoop() {
        if (test == 0) {
            String c = "There was a loFty ship 8 *";
            log("sending: " + c);
            kb.sendKeys(c);
        }else
	if(test == 1){
	    int x= (int)(Math.random() * appletSize.width);
	    int y= (int)(Math.random() * appletSize.height);
            log("left clicking at "+x+","+y);
            mouse.clickMouse(x, x, Mouse.LEFT_BUTTON);
            log("Right clicking at "+x+","+y);
            mouse.clickMouse(x, x, Mouse.RIGHT_BUTTON);
        }else
	if(test == 2){
	    int x= (int)(Math.random() * appletSize.width);
	    int y= (int)(Math.random() * appletSize.height);
	    log("moving to "+x+","+y);
	    try{
		mouse.moveMouse(x,y);
	    }
	    catch(ArithmeticException ex){
		System.out.println("Exception with Benmouse, using MutantRsN");
		mouse.setMousePathGen(new MutantRsNLine());
		mouse.moveMouse(x,y);
		mouse.setMousePathGen(new Spline());
            }
	}else
	if(test == 3){
		log("Sleeping for 2000 msec");
	}else
	if(test == 4){
		log("args.length = "+args.length);
		for(int f=0; f<args.length; f++){

			log("args["+f+"] = '"+args[f]+"'");
		}
		stopScript("Reached the end");
	}else
	if(test == 5){
		int x,y;
		int ex,ey;
		y= (int)(Math.random() * appletSize.height);
		ey= y + 2 - (int)(Math.random() * 5);
		if(anInt % 2 == 0){
			x= 0;
			ex= x - (int)(Math.random() * 5);
		}else{
			x= appletSize.width;
			ex= x + (int)(Math.random() * 5);
		}
		anInt++;
		mouse.setMousePathGen(new MutantRsNLine());
		mouse.moveMouse(x,y);
		mouse.setMousePathGen(new Spline());
		mouse.exitMouse(ex,ey);
		try{Thread.sleep(3000);
		}catch(Exception e){}
		mouse.enterMouse(x,y);
	}

        try {
            Thread.sleep(2000);
        } catch (Exception e) {
            log("Exception in TestScript mainLoop()");
            e.printStackTrace();
        }
    }

    public void scriptEnding() {
	log("freeing... nothing");
    }
}